#!/usr/bin/env python

# GetUSGNName.pyw

'''
This file belongs to GetUSGNName, a Lua/Python module (written for Counter-Strike: 2D)
which fetches the Unreal Software login names of players.


It can be used both in combination with the belonging Lua script and as a standalone
console application (same goes for the Windows executable). Usage is simple:

	python GetUSGNName.pyw USGN [SAVE]

USGN should be replaced by a USGN ID #.
Adding SAVE after the USGN will save the name to the saves file (USGNNames/{USGN}) in a simple
syntax:
	
	timeNAME

Example for usage:

	user@test:~$ python GetUSGNName.pyw 12345
	batman007

or:

	user@test:~$ python GetUSGNName.pyw 56789 SAVE
	Shock

which will write the current time (as given by time.time()), followed by Shock to USGNNames/56789


Don't mind the strange %ERROR% errors, that's just for the Lua to recognize the output,
but keep it in a readable fashion.


This code has been tested with Python 2.5 on Linux (OpenSUSE 10.3) and Python 2.7 on Windows (Vista).


I guess that was about all, take a look at the readme that should be somewhere within the ZIP
file you downloaded for more info ;)



                                   25/03/11 - http://www.cs2d.nl
'''


import urllib2, re, sys, os, time
from htmlentitydefs import name2codepoint as n2cp

DIR = os.path.dirname(os.path.abspath(__file__))
print DIR

def substitute_entity(match):
	ent = match.group(3)
	
	if match.group(1) == "#":
		if match.group(2) == '':
			return unichr(int(ent))
		elif match.group(2) == 'x':
			return unichr(int('0x'+ent, 16))
	else:
		cp = n2cp.get(ent)

		if cp:
			return unichr(cp)
		else:
			return match.group()

def HTMLDecode(string):
	entity_re = re.compile(r'&(#?)(x?)(\d{1,5}|\w{1,8});')
	return entity_re.subn(substitute_entity, string)[0]




if len(sys.argv) < 2:
	print '%ERROR%No USGN ID specified'
	sys.exit()
else:
	UID = sys.argv[1]

try:
	req = urllib2.urlopen("http://unrealsoftware.de/profile.php?userid=" + UID)
	page = req.read()
	if page.find('<div class="fa" style="top:5px; color:#FFF;">') == -1:
		print("%ERROR%This user does not exist")
		
	else:
		start = page.find("<h1>")
		end = page.find("<", start + 4)
		
		name = HTMLDecode(page[start+4:end].strip())

		print(name)
		
		if sys.argv[2] == "SAVE":
			try:
				f = open(DIR + "/USGNNames/" + UID, "w")
				f.write(str(int(time.time())) + name)
				f.close()
			except:
				print("%ERROR%could not open save file")

except Exception, e:
	if hasattr(e, 'reason'):
		print("%ERROR%" + str(e.reason))
	elif hasattr(e, 'code'):
		print("%ERROR%" + str(e.code))
